/* APPLMSG.H -- Example host application message handler function prototypes.
 * Copyright (c) 1993,1994 by Echelon Corporation.
 * All Rights Reserved.
 *
 * Date last modified: 11/17/94
 */

#include "ha_comn.h"

extern Bool processMsg( void );
extern void loadNvConfig( void );
extern void storeNvConfig( void );
extern Word matchNvConfig( UnprocessedNV * inNv );
extern Bool updateNvValue( Word nvIndex, Byte * data, int size );
extern Bool handleNetvarUpdate( UnprocessedNV * inNV, Byte inLength,
    Bool inAuth );

#define NUM_NVS 8
            // Number of Network Variable table entries on this node

typedef struct {                         // structure to define NV storage
    int             size;                // number of bytes
    const char    * name;                // name of variable
    void            ( * printFunc )( Byte * ); // routine to print value
    void            ( * readFunc  )( Byte * ); // routine to read value
    Byte            data[ MAX_NETVAR_DATA ];   // actual storage for value
} NvData;

extern NvData NvValueTable[ ];
extern nv_struct NvConfigTable[ ];
extern Bool onlineFlag;

#define NULL_NV_INDEX   0xFFFF

// prototypes for I/O functions

extern void printAsc  ( Byte * );
extern void printDisc ( Byte * );
extern void printCont ( Byte * );
extern void printFloat( Byte * );
extern void readAsc   ( Byte * );
extern void readDisc  ( Byte * );
extern void readCont  ( Byte * );
extern void readFloat ( Byte * );
