/* LDVINTFC.H -- LONWORKS(R) standard network interface functions.
 * Copyright (c) 1993 by Echelon Corporation.
 * All Rights Reserved.
 *
 * Date last modified: 10/7/94
 *
 *
 ****************************************************************************
 * Network driver error codes.
 ****************************************************************************
 */

typedef enum {
    LDV_OK = 0,
    LDV_NOT_FOUND,
    LDV_ALREADY_OPEN,
    LDV_NOT_OPEN,
    LDV_DEVICE_ERR,
    LDV_INVALID_DEVICE_ID,
    LDV_NO_MSG_AVAIL,
    LDV_NO_BUFF_AVAIL,
    LDV_NO_RESOURCES,
    LDV_INVALID_BUF_LEN,
    LDV_DEVICE_BUSY
} LDVCode;

/*
 ****************************************************************************
 * Standard network driver functions.
 ****************************************************************************
 */

typedef short LNI;          // device handle

LDVCode ldv_open( const char * deviceName, LNI * pHandle );
            /* Open network interface device - returns device handle */

LDVCode ldv_read( LNI handle, void * pMsg, short length );
            /* Read a buffer */

LDVCode ldv_write( LNI handle, void * pMsg, short length );
            /* Write a buffer */

LDVCode ldv_close( LNI handle );
           /* Close network interface device */

void ldvErrorDisplay( const char * str, LDVCode ldvError );
                                     /* Display a network driver error   */

