/****************************************************************************
 *  Filename:     ni_callb.h
 *
 *  Description:  This include file contains definitions for the
 *                callback functions.
 *
 *  Copyright (c) 1994 Echelon Corporation.  All Rights Reserved.
 *
 ***************************************************************************/

#include "ha_comn.h"

typedef Bool ( * NiCallbackProc )( ExpAppBuffer * pMsgIn );

typedef enum {
   APP_MSG_CALLBACK = 0,
   NV_POLL_CALLBACK,
   NV_UPDATE_CALLBACK,

   WINK_CALLBACK,
   QUERY_SNVT_CALLBACK,
   NV_FETCH_CALLBACK,
   QUERY_NV_CNFG_CALLBACK,
   UPDATE_NV_CNFG_CALLBACK,
   SET_NODE_MODE_CALLBACK,
   SERVICE_PIN_CALLBACK,

   INVALID_RESP_CALLBACK,
   UPLINK_CMD_CALLBACK,

   // Add new callback procedures above here

   NUM_CALLBACKS
} CallbackType;

typedef struct
{
   NiCallbackProc proc;
   Byte           nmCommand;
} NiCallbackData;

// General purpose command callback

extern Bool NiCommandCallback( ExpAppBuffer * pMsgIn );
extern Bool NiInvokeCallback( CallbackType type, ExpAppBuffer * pMsgIn );

// Handler routines for specific incoming messages

extern Bool NiHandleAppMsgs       ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleNvPoll        ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleNvUpdate      ( ExpAppBuffer * pMsgIn );

extern Bool NiHandleWink          ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleQuerySnvt     ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleNvFetch       ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleQueryNvConfig ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleUpdateNvConfig( ExpAppBuffer * pMsgIn );
extern Bool NiHandleSetNodeMode   ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleServicePinMsg ( ExpAppBuffer * pMsgIn );

extern Bool NiHandleInvalidResp   ( ExpAppBuffer * pMsgIn );
extern Bool NiHandleUplinkCmd     ( ExpAppBuffer * pMsgIn );
